﻿-- version 1.024

hkills = {};
hkills["version"] = 1.024;

local HKFrame = CreateFrame("Frame", nil, UIParent);
local menuFrame = CreateFrame("Frame", "HKills1", UIParent, "UIDropDownMenuTemplate")

local menu = {
    { text = "HKills v1.023", isTitle = true},
    { text = "Сбросить счетчик почетных побед", func = function() HKFrame:resetCounter(); end },
	
    { text = "Показ HKM (Килов в минуту)", hasArrow = true,
        menuList = {
            { text = "Отобразить", func = function() hkills["isShowHKS"] = 1; HKFrame:updateStats(); end },
			{ text = "Скрыть", func = function() hkills["isShowHKS"] = 0; HKFrame:updateStats(); end }
        } 
    },	

    { text = "Общее количество килов", hasArrow = true,
        menuList = {
            { text = "Отобразить", func = function() hkills["isShowAllHK"] = 1; HKFrame:updateStats(); end },
			{ text = "Скрыть", func = function() hkills["isShowAllHK"] = 0; HKFrame:updateStats(); end }
        } 
    },	
	
    { text = "Обновить (пересчитать) данные", func = function() HKFrame:updateStats(); end },
	{ text = "Скрыть (/hkills show для отображения)", func = function() HKFrame:Hide(); end },
--	{ text = "Тест (!!!НЕ НАЖИМАТЬ!!!)", func = function() test(); end },
    { text = "Об аддоне", func = function() HKillsAbout(); end }
}

-- основной
NoKillHordeFrameBig = CreateFrame("Frame", nil, UIParent);
NoKillHordeFrameBig:SetFrameStrata("BACKGROUND");
NoKillHordeFrameBig:SetWidth(220) ;
NoKillHordeFrameBig:SetHeight(240);
NoKillHordeFrameBig:SetPoint("CENTER", "UIParent", "CENTER", 0, 70);
NoKillHordeFrameBig:SetBackdrop(GameTooltip:GetBackdrop());
NoKillHordeFrameBig:SetBackdropColor(0.3, 0.3, 0.3);
NoKillHordeFrameBig:Hide();

-- мелкий 1
local NoKillHordeFrame1 = CreateFrame("Frame", nil, UIParent);
NoKillHordeFrame1:SetFrameStrata("BACKGROUND");
NoKillHordeFrame1:SetWidth(220) ;
NoKillHordeFrame1:SetHeight(60);
NoKillHordeFrame1:SetPoint("TOP", "NoKillHordeFrameBig", "TOP", 0, 0);
NoKillHordeFrame1:SetBackdrop(GameTooltip:GetBackdrop());
NoKillHordeFrame1:SetBackdropColor(0.3, 0.3, 0.3);
-- надпись мелкого 1
NoKillHordeFrame1.text = NoKillHordeFrame1:CreateFontString(nil, "BACKROUND", "GameFontNormalLarge");
NoKillHordeFrame1.text:SetTextColor(1,0,0);
NoKillHordeFrame1.text:SetWidth(220);
NoKillHordeFrame1.text:SetHeight(60);
NoKillHordeFrame1.text:SetPoint("CENTER", NoKillHordeFrame1, "CENTER", 0, 0);
NoKillHordeFrame1.text:SetText("НЕ БЕЙ ОРДУ, ПОДЛЕЦ!!!");
NoKillHordeFrame1:Hide();


-- мелкий 2
local NoKillHordeFrame2 = CreateFrame("Frame", nil, UIParent);
NoKillHordeFrame2:SetFrameStrata("BACKGROUND");
NoKillHordeFrame2:SetWidth(220) ;
NoKillHordeFrame2:SetHeight(60);
NoKillHordeFrame2:SetPoint("TOP", "NoKillHordeFrameBig", "TOP", 0, -60);
NoKillHordeFrame2:SetBackdrop(GameTooltip:GetBackdrop());
NoKillHordeFrame2:SetBackdropColor(0.3, 0.3, 0.3);
-- надпись мелкого 2
NoKillHordeFrame2.text = NoKillHordeFrame1:CreateFontString(nil, "BACKROUND", "GameFontNormalLarge");
NoKillHordeFrame2.text:SetTextColor(1,0,0);
NoKillHordeFrame2.text:SetWidth(220);
NoKillHordeFrame2.text:SetHeight(60);
NoKillHordeFrame2.text:SetPoint("CENTER", NoKillHordeFrame2, "CENTER", 0, 0);
NoKillHordeFrame2.text:SetText("НЕ БЕЙ ОРДУ, ПОДЛЕЦ!!!");
NoKillHordeFrame2:Hide();


-- мелкий 3
local NoKillHordeFrame3 = CreateFrame("Frame", nil, UIParent);
NoKillHordeFrame3:SetFrameStrata("BACKGROUND");
NoKillHordeFrame3:SetWidth(220) ;
NoKillHordeFrame3:SetHeight(60);
NoKillHordeFrame3:SetPoint("TOP", "NoKillHordeFrameBig", "TOP", 0, -120);
NoKillHordeFrame3:SetBackdrop(GameTooltip:GetBackdrop());
NoKillHordeFrame3:SetBackdropColor(0.3, 0.3, 0.3);
-- надпись мелкого 3
NoKillHordeFrame3.text = NoKillHordeFrame1:CreateFontString(nil, "BACKROUND", "GameFontNormalLarge");
NoKillHordeFrame3.text:SetTextColor(1,0,0);
NoKillHordeFrame3.text:SetWidth(220);
NoKillHordeFrame3.text:SetHeight(60);
NoKillHordeFrame3.text:SetPoint("CENTER", NoKillHordeFrame3, "CENTER", 0, 0);
NoKillHordeFrame3.text:SetText("НЕ БЕЙ ОРДУ, ПОДЛЕЦ!!!");
NoKillHordeFrame3:Hide();


-- мелкий 4
local NoKillHordeFrame4 = CreateFrame("Frame", nil, UIParent);
NoKillHordeFrame4:SetFrameStrata("BACKGROUND");
NoKillHordeFrame4:SetWidth(220) ;
NoKillHordeFrame4:SetHeight(60);
NoKillHordeFrame4:SetPoint("TOP", "NoKillHordeFrameBig", "TOP", 0, -180);
NoKillHordeFrame4:SetBackdrop(GameTooltip:GetBackdrop());
NoKillHordeFrame4:SetBackdropColor(0.3, 0.3, 0.3);
-- надпись мелкого 4
NoKillHordeFrame4.text = NoKillHordeFrame1:CreateFontString(nil, "BACKROUND", "GameFontNormalLarge");
NoKillHordeFrame4.text:SetTextColor(1,0,0);
NoKillHordeFrame4.text:SetWidth(220);
NoKillHordeFrame4.text:SetHeight(60);
NoKillHordeFrame4.text:SetPoint("CENTER", NoKillHordeFrame4, "CENTER", 0, 0);
NoKillHordeFrame4.text:SetText("НЕ БЕЙ ОРДУ, ПОДЛЕЦ!!!");
NoKillHordeFrame4:Hide();

HKFrame:SetFrameStrata("BACKGROUND");
HKFrame:SetWidth(200) ;
HKFrame:SetHeight(80);
HKFrame:SetPoint("CENTER", "UIParent");
HKFrame.text = HKFrame:CreateFontString(nil, "BACKROUND", "GameFontNormalLarge");
HKFrame.text:SetTextColor(1,0,0);
HKFrame.text:SetWidth(200);
HKFrame.text:SetHeight(80);
HKFrame.text:SetPoint("CENTER", HKFrame, "CENTER");
HKFrame:SetBackdrop(GameTooltip:GetBackdrop());
HKFrame:SetBackdropColor(0.3, 0.3, 0.3);
HKFrame:RegisterEvent("PLAYER_PVP_KILLS_CHANGED");
HKFrame:RegisterEvent("PLAYER_TARGET_CHANGED");
HKFrame:SetScript("OnDragStart", HKFrame.StartMoving);
HKFrame:SetScript("OnDragStop", function()
									HKFrame:StopMovingOrSizing();
									hkills["point"], _, hkills["relativePoint"], hkills["xpos"], hkills["ypos"] = HKFrame:GetPoint();
									--hkills["width"] = HKFrame:GetWidth();
									--hkills["height"] = HKFrame:GetHeight();
								end);

								
HKFrame:SetScript("OnMouseDown", function (self, button)
									if button == "RightButton" then
										EasyMenu(menu, menuFrame, "cursor", 0 , 0, "MENU", 1);
									end;
								 end);								 


HKFrame:SetMovable(true);
HKFrame:EnableMouse(true);
HKFrame:RegisterForDrag("LeftButton");

HKFrame:SetScript("OnEvent", function(self,event,...)
	--DEFAULT_CHAT_FRAME:AddMessage("HKILLS: "..event);
	--hkills["localHK"] = hkills["localHK"] + 1;
	if event == "PLAYER_PVP_KILLS_CHANGED" then
		if hkills["startHKpos"] == 0 then
			hkills["startHKpos"] = GetPVPLifetimeStats()
		end;
		
		if GetPVPLifetimeStats() - hkills["startHKpos"] == 1 then -- установка таймера с первым килом
			hkills["startTime"] = time() - 1;
		end;	
		
		HKFrame:updateStats();
	end;
	
 --if event == "PLAYER_TARGET_CHANGED" then
		--mybuff = UnitBuff("player", "Курительница вечной агонии");
	--	targetbuff = UnitBuff("target", "Курительница вечной агонии");
		--if mybuff and strupper(tostring(UnitFactionGroup("target"))) == "HORDE" and not targetbuff then
		--	--DEFAULT_CHAT_FRAME:AddMessage("mybuff - "..tostring(mybuff).." фракция таргета - "..tostring(UnitFactionGroup("target")).." бафтергета "..tostring(targetbuff));
		--	NoKillHordeFrameBig:Show();
		--	NoKillHordeFrame1:Show();
		--	NoKillHordeFrame2:Show();
		--	NoKillHordeFrame3:Show();
		--	NoKillHordeFrame4:Show();
		--else
			--NoKillHordeFrame1:Hide();
			--NoKillHordeFrame2:Hide();
			--NoKillHordeFrame3:Hide();
			--NoKillHordeFrame4:Hide();
			--NoKillHordeFrameBig:Hide();
		--end;
	--end;
end)

-- устанавливаем параметры фрейма после полной загрузки аддона
local DummyFrame = CreateFrame("Frame");
DummyFrame:RegisterEvent("ADDON_LOADED");
DummyFrame:SetScript("OnEvent", function(self,event,arg1)
	if arg1 == "HKills" then
	
		--if not hkills["localHK"] then
			--hkills["localHK"] = 0;
		--end;
		
		--if hkills["width"] then
			--HKFrame:SetWidth(hkills["width"]);
		--end;
		--if hkills["height"] then
			--HKFrame:SetHeight(hkills["height"]);
		--end;
		
		if not hkills["point"] then
			hkills["point"] = "CENTER";
		end;
		if not hkills["relativePoint"] then
			hkills["relativePoint"] = "CENTER";
		end;
		if not hkills["xpos"] then
			hkills["xpos"] = 0;
		end;
		if not hkills["ypos"] then
			hkills["ypos"] = 0;
		end;
		HKFrame:SetPoint(hkills["point"], "UIParent", hkills["relativePoint"], hkills.xpos, hkills.ypos);
		if not hkills["startHKpos"] then
			hkills["startHKpos"] = 0;
		end;
		
		if not hkills["startTime"] then
			hkills["startTime"] = 0;
		end;
		
		if not hkills["isShowHKS"] then
			hkills["isShowHKS"] = 1;
		end;
		
		if not hkills["isShowAllHK"] then
			hkills["isShowAllHK"] = 1;
		end;
		
		HKFrame:updateStats();

		HKFrame:Show();
	end;
end)

SLASH_HKILLS1 = "/hkills"
SlashCmdList["HKILLS"] = function(msg, _)

	if strupper(msg) == "SHOW" then
		HKFrame:Show();
	end;

	if strupper(msg) == "?" then
		HKillsAbout();
	end;
	
	if strupper(msg) == "RC" then
		HKFrame:resetCounter();
	end;
	
	if strupper(msg) == "RESETPOSITION" then
		hkills["point"] = "CENTER";
		hkills["relativePoint"] = "CENTER";
		hkills["xpos"] = 0;
		hkills["ypos"] = 0;
		DEFAULT_CHAT_FRAME:AddMessage("HKILLS: Для сброса местоположения фрейма счетчика сделайте /reload ");
	end;
end;

function HKFrame.resetCounter()
	hkills["startHKpos"] = GetPVPLifetimeStats();
	hkills["startTime"] = time() - 1;
	if hkills["startHKpos"] == 0 then
		DEFAULT_CHAT_FRAME:AddMessage("HKILLS: Счетчик почетных побед НЕ обнулен, попробуйте еще раз!");
	else
		DEFAULT_CHAT_FRAME:AddMessage("HKILLS: Счетчик почетных побед обнулен!");
	end;
	HKFrame:updateStats();
end;

function HKFrame.updateStats()
	if hkills["startHKpos"] == 0 then 
		hkills["startHKpos"] = GetPVPLifetimeStats();
		hkills["startTime"] = time() - 1;
	end;
	if GetPVPLifetimeStats() == 0 then
		HKFrame.text:SetText("Обновите данные".."\n(меню по правому клику)");
		--HKFrame.text:SetText("Счетчик HK: ".."Считаем...".."\n(Всего HK: ".."Считаем..."..")");
		return;
	end;
	
	if hkills["isShowHKS"] == 1 then
		HKSstring = "\nHK в минуту: "..HKSround((GetPVPLifetimeStats() - hkills["startHKpos"]) / ((time() - hkills["startTime"])/60), 2).."\n("..GetPVPLifetimeStats() - hkills["startHKpos"].." килов за "..HKSround((time() - hkills["startTime"])/60, 0).." минут)";
	else
		HKSstring = " ";
	end;	
	
	if hkills["isShowAllHK"] == 1 then
		AllHKstring = "\nВсего HK: "..GetPVPLifetimeStats();
	else
		AllHKstring = " ";
	end;
	
	HKFrame.text:SetText("Счетчик HK: "..GetPVPLifetimeStats() - hkills["startHKpos"]..HKSstring..AllHKstring);
	--HKFrame.text:SetText("Счетчик HK: "..GetPVPLifetimeStats() - hkills["startHKpos"].."\n(Всего HK: "..GetPVPLifetimeStats()..")");
end;

function HKSround(num, idp)
	local mult = 10^(idp or 0)
	return math.floor(num * mult + 0.5) / mult;
end;

function HKillsAbout()
	DEFAULT_CHAT_FRAME:AddMessage("HKILLS: v."..hkills["version"]);
	DEFAULT_CHAT_FRAME:AddMessage("HKILLS: Аддон создан для участников сообщества |cFFC41F3B Эшелон |r (echelon-community.com/");
	DEFAULT_CHAT_FRAME:AddMessage("HKILLS: Автор Бузилко@CC");
end;

function test()
	DEFAULT_CHAT_FRAME:AddMessage("Моя фракция - "..tostring(UnitFactionGroup("player")));
	DEFAULT_CHAT_FRAME:AddMessage("Фракция таргета - "..tostring(UnitFactionGroup("target")));
	name, rank, icon, count, debuffType, duration, expirationTime, unitCaster, isStealable, shouldConsolidate, spellId = UnitBuff("player", "Курительница вечной агонии");
	DEFAULT_CHAT_FRAME:AddMessage("Бафф - "..tostring(name));
	
	name, rank, icon, count, debuffType, duration, expirationTime, unitCaster, isStealable, shouldConsolidate, spellId = UnitBuff("player", "Курительница вечной агонии1");
	DEFAULT_CHAT_FRAME:AddMessage("Кривой бафф - "..tostring(name));
	NoKillHordeFrame:Show();
end;